/*
   Copyright (c) 2017, MariaDB

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1335  USA */

#include <my_global.h>
#include <string.h>

const char *my_dlerror(const char *dlpath)
{
  const char *errmsg=dlerror();
  size_t dlpathlen= strlen(dlpath);
  if (!strncmp(dlpath, errmsg, dlpathlen))
  { /* if errmsg starts from dlpath, trim this prefix */
    errmsg+=dlpathlen;
    if (*errmsg == ':') errmsg++;
    if (*errmsg == ' ') errmsg++;
  }
  return errmsg;
}
